package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AreaInfo;
import com.izouma.awesomeadmin.service.AreaInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/areaInfo")
public class AreaInfoController {

    @Autowired
    private AreaInfoService areaInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AreaInfo record) {
        List<AreaInfo> pp = areaInfoService.getAreaInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getAreaInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getAreaInfo(@RequestParam(required = false, value = "id") String id) {
        AreaInfo data = areaInfoService.getAreaInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AreaInfo record) {
        AreaInfo data = areaInfoService.getAreaInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AreaInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<AreaInfo> pp =areaInfoService.getAreaInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AreaInfo record) {
        boolean num = areaInfoService.createAreaInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAreaInfo(AreaInfo record) {
        boolean num = areaInfoService.updateAreaInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAreaInfo(AreaInfo record) {

        boolean num = areaInfoService.deleteAreaInfo(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AreaInfo record) throws Exception {

    List<AreaInfo> areaInfos = areaInfoService.getAreaInfoList(record);


        String sheetName = "area_info";
        String titleName = "区域数据表";
        String fileName = "区域表";
        int columnNumber = 25;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "权限" ,   "城市ID" ,   "地标ID" ,   "区域名称" ,   "优先级" ,   "允许编辑" ,   "允许导航" ,   "公共区域" ,   "备注" ,   "ICON" ,   "关键字" ,   "视频" ,   "文字介绍" ,   "官网" ,   "显示距离" ,   "模板ID" ,   "上级ID" ,   "地块ID" ,   "区域类型"  };
        String[][] dataList = new String[areaInfos.size()][25];

        for (int i = 0; i < areaInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(areaInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(areaInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(areaInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(areaInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(areaInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(areaInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(areaInfos.get(i).getPower());
                        dataList[i][7] = String.valueOf(areaInfos.get(i).getCityId());
                        dataList[i][8] = String.valueOf(areaInfos.get(i).getLandmarkId());
                        dataList[i][9] = String.valueOf(areaInfos.get(i).getAreaName());
                        dataList[i][10] = String.valueOf(areaInfos.get(i).getRankLevel());
                        dataList[i][11] = String.valueOf(areaInfos.get(i).getAllowEdit());
                        dataList[i][12] = String.valueOf(areaInfos.get(i).getAllowNavigate());
                        dataList[i][13] = String.valueOf(areaInfos.get(i).getPublicArea());
                        dataList[i][14] = String.valueOf(areaInfos.get(i).getRemark());
                        dataList[i][15] = String.valueOf(areaInfos.get(i).getIcon());
                        dataList[i][16] = String.valueOf(areaInfos.get(i).getKeyword());
                        dataList[i][17] = String.valueOf(areaInfos.get(i).getVideo());
                        dataList[i][18] = String.valueOf(areaInfos.get(i).getTextIntroduction());
                        dataList[i][19] = String.valueOf(areaInfos.get(i).getUrl());
                        dataList[i][20] = String.valueOf(areaInfos.get(i).getShowDistance());
                        dataList[i][21] = String.valueOf(areaInfos.get(i).getTemplateId());
                        dataList[i][22] = String.valueOf(areaInfos.get(i).getFrontLevelId());
                        dataList[i][23] = String.valueOf(areaInfos.get(i).getBlockId());
                        dataList[i][24] = String.valueOf(areaInfos.get(i).getAreaType());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

